package ProjectStormtrooper;

import javax.swing.*;
import java.awt.*;
import javax.swing.JColorChooser;
import java.util.Random;
import java.awt.event.ActionListener;

public class FormStormtrooper extends JDialog {
    public DrawingPlane _drawingPlane;
    AbstractStrategy _abstractStrategy;
    private JButton buttonCreateStormtrooper;
    private JPanel pictureBox;
    private JButton buttonDown;
    private JButton buttonUp;
    private JButton buttonLeft;
    private JButton buttonRight;
    private JButton buttonCreatePlane;
    private JComboBox comboBoxStrategy;
    private JButton buttonStep;
    public JButton buttonSelectPlane;

    public JPanel getPictureBox() {
        return pictureBox;
    }

    public FormStormtrooper() {
        buttonUp.setName("buttonUp");
        buttonDown.setName("buttonDown");
        buttonLeft.setName("buttonLeft");
        buttonRight.setName("buttonRight");


        buttonCreateStormtrooper.addActionListener(e -> {
            Random random = new Random();

            Color color = JColorChooser.showDialog(this.pictureBox, "Выберите цвет", Color.BLACK);
            Color additionalColor = JColorChooser.showDialog(this.pictureBox, "Выберите дополнительный цвет", Color.BLACK);


            _drawingPlane = new DrawingStormtrooper(
                    random.nextInt(100, 300),
                    random.nextInt(1000, 3000),
                    color,
                    additionalColor,
                    random.nextBoolean(),
                    random.nextBoolean(),
                    pictureBox.getWidth(),
                    pictureBox.getHeight()
            );

            _drawingPlane.SetEnginesCount(random.nextInt(2, 7));
            _drawingPlane.SetPosition(random.nextInt(10, 100), random.nextInt(10, 100));

            Draw();
        });

        buttonCreatePlane.addActionListener(e -> {
            Random random = new Random();

            Color color = JColorChooser.showDialog(this.pictureBox, "Выберите цвет", Color.BLACK);

            _drawingPlane = new DrawingPlane(
                    random.nextInt(100, 300),
                    random.nextInt(1000, 3000),
                    color,
                    pictureBox.getWidth(),
                    pictureBox.getHeight()
            );

            _drawingPlane.SetEnginesCount(random.nextInt(2, 7));
            _drawingPlane.SetPosition(random.nextInt(10, 100), random.nextInt(10, 100));

            Draw();
        });

        buttonStep.addActionListener(e -> {
            if (_drawingPlane == null)
                return;
            if (comboBoxStrategy.isEnabled()) {
                _abstractStrategy = null;
                int comboBoxStrategySelectedIndex = comboBoxStrategy.getSelectedIndex();
                if (comboBoxStrategySelectedIndex == 0) {
                    _abstractStrategy = new MoveToCenter();
                } else if (comboBoxStrategySelectedIndex == 1) {
                    _abstractStrategy = new MoveToRightBottom();
                }
                if (_abstractStrategy == null)
                    return;
                _abstractStrategy.SetData(new DrawingObjectPlane(_drawingPlane), pictureBox.getWidth(), pictureBox.getHeight());
                comboBoxStrategy.setEnabled(false);
            }
            if (_abstractStrategy == null)
                return;
            _abstractStrategy.MakeStep();
            Draw();
            if (_abstractStrategy.GetStatus() == Status.Finish) {
                comboBoxStrategy.setEnabled(true);
                _abstractStrategy = null;
            }
        });


        ActionListener buttonMoveClickedListener = e -> {
            String buttonName = ((JButton) e.getSource()).getName();

            switch (buttonName) {
                case ("buttonUp") -> {
                    _drawingPlane.MoveTransport(EnumDirectionType.Up);
                }
                case ("buttonDown") -> {
                    _drawingPlane.MoveTransport(EnumDirectionType.Down);
                }
                case ("buttonLeft") -> {
                    _drawingPlane.MoveTransport(EnumDirectionType.Left);
                }
                case ("buttonRight") -> {
                    _drawingPlane.MoveTransport(EnumDirectionType.Right);
                }
            }

            Draw();
        };

        buttonUp.addActionListener(buttonMoveClickedListener);
        buttonDown.addActionListener(buttonMoveClickedListener);
        buttonLeft.addActionListener(buttonMoveClickedListener);
        buttonRight.addActionListener(buttonMoveClickedListener);
    }

    public void Draw() {
        if (_drawingPlane == null) {
            return;
        }

        Graphics g = pictureBox.getGraphics();
        pictureBox.paint(g);
        _drawingPlane.DrawTransport(g);
    }

    private void createUIComponents() {
        String[] strategiesList = {
                "MoveToCenter",
                "MoveToRightBottom"
        };
        comboBoxStrategy = new JComboBox(strategiesList);
    }
}
